## gazebo 11.8.0+dfsg

=== CMakeLists.txt ===
if(WIN32)
  cmake_minimum_required(VERSION 3.11 FATAL_ERROR)
else()
  cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
endif()

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0004 NEW)
endif(COMMAND CMAKE_POLICY)

if(POLICY CMP0100)
  cmake_policy(SET CMP0100 NEW)
endif()

project (Gazebo)
string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
string (TOUPPER ${PROJECT_NAME} PROJECT_NAME_UPPER)

set (GAZEBO_MAJOR_VERSION 11)
set (GAZEBO_MINOR_VERSION 8)
# The patch version may have been bumped for prerelease purposes; be sure to
# check gazebo-release/ubuntu/debian/changelog@default to determine what the
# next patch version should be for a regular release.
set (GAZEBO_PATCH_VERSION 0)

set (GAZEBO_VERSION ${GAZEBO_MAJOR_VERSION}.${GAZEBO_MINOR_VERSION})
set (GAZEBO_VERSION_FULL ${GAZEBO_MAJOR_VERSION}.${GAZEBO_MINOR_VERSION}.${GAZEBO_PATCH_VERSION})

message (STATUS "${PROJECT_NAME} version ${GAZEBO_VERSION_FULL}")

set (gazebo_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH "Location of CMake scripts")

if(DEFINED ENABLE_TESTS_COMPILATION)
 message(FATAL_ERROR "The parameter ENABLE_TESTS_COMPILATION is deprecated. "
   "The new behaviour is to call 'make tests' explicitly to compile the test"
   "suite. Calling 'make' or 'make all' won't compile the tests")
endif()

if(NOT DEFINED BUILD_TESTING)
    set(BUILD_TESTING OFF)
endif()

option(ENABLE_PROFILER "Enable Ignition Profiler" FALSE)

if(ENABLE_PROFILER)
  add_definitions("-DIGN_PROFILER_ENABLE=1")
else()
  add_definitions("-DIGN_PROFILER_ENABLE=0")
endif()

#============================================================================
# We turn off extensions because (1) we do not ever want to use non-standard
# compiler extensions, and (2) this variable is on by default, causing cmake
# to choose the flag -std=gnu++14 instead of -std=c++14 when the C++14
# features are requested. Explicitly turning this flag off will force cmake to
# choose -std=c++14.
# See https://github.com/ignitionrobotics/ign-cmake/issues/13 for more info.
set(CMAKE_CXX_EXTENSIONS off)

########################################
# Package Creation:
include (${gazebo_cmake_dir}/gazebo_cpack.cmake)
set (CPACK_PACKAGE_VERSION "${GAZEBO_VERSION_FULL}")
set (CPACK_PACKAGE_VERSION_MAJOR "${GAZEBO_MAJOR_VERSION}")
set (CPACK_PACKAGE_VERSION_MINOR "${GAZEBO_MINOR_VERSION}")
set (CPACK_PACKAGE_VERSION_PATCH "${GAZEBO_PATCH_VERSION}")

if (CPACK_GENERATOR)
  message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")

  configure_file("${gazebo_cmake_dir}/cpack_options.cmake.in" ${GAZEBO_CPACK_CFG_FILE} @ONLY)
  set(CPACK_PROJECT_CONFIG_FILE ${GAZEBO_CPACK_CFG_FILE})
  include (CPack)
endif()

# If we're configuring only to package source, stop here
if (PACKAGE_SOURCE_ONLY)
  message(WARNING "Configuration was done in PACKAGE_SOURCE_ONLY mode.  You can build a tarball (make package_source), but nothing else.")
  return()
endif()

# Documentation
add_subdirectory(doc)

# Configure documentation uploader
configure_file("${CMAKE_SOURCE_DIR}/cmake/upload_doc.sh.in"
  ${CMAKE_BINARY_DIR}/upload_doc.sh @ONLY)

# If we're configuring only to build docs, stop here
if (DOC_ONLY)
  message(WARNING "Configuration was done in DOC_ONLY mode.  You can build documentation (make doc), but nothing else.")
  return()
endif()

enable_testing()

# Use GNUInstallDirst to get canonical paths
include(GNUInstallDirs)

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)


# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()


set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/gazebo-${GAZEBO_MAJOR_VERSION}/gazebo")
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})

set (BUILD_GAZEBO ON CACHE INTERNAL "Build Gazebo" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)


set (MIN_OGRE_VERSION 1.7.4 CACHE INTERNAL "Ogre version requirement" FORCE)
set (MIN_BOOST_VERSION 1.40.0 CACHE INTERNAL "Boost min version requirement" FORCE)

set (FREEIMAGE_MAJOR_VERSION 3 CACHE INTERNAL "FreeImage major version requirement" FORCE)
set (FREEIMAGE_MINOR_VERSION 9 CACHE INTERNAL "FreeImage minor version requirement" FORCE)
set (MIN_FREEIMAGE_VERSION ${FREEIMAGE_MAJOR_VERSION}.${FREEIMAGE_MINOR_VERSION}.0 CACHE INTERNAL "FreeImage version requirement" FORCE)

include (${gazebo_cmake_dir}/DissectVersion.cmake)

#####################################
# Check for low memory version to use in some tests
if(NOT DEFINED USE_LOW_MEMORY_TESTS)
  set (USE_LOW_MEMORY_TESTS FALSE)
  message (STATUS "High memory tests: enabled")
else()
  set (USE_LOW_MEMORY_TEST TRUE)
  message (STATUS "High memory tests: disabled, low memory versions will be used")
endif()

######################################
# Enable screen tests by default
if(NOT DEFINED ENABLE_SCREEN_TESTS)
  set(ENABLE_SCREEN_TESTS TRUE)
endif()

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
include (${gazebo_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")

#####################################
# Define some variables that are going to be used in two places:
# 1. In CMake code to pass preprocessor definitions to certain source files
# (especially in common/CMakeLists.txt).
# 2. In the generation of cmake/setup.sh from cmake/setup.sh.in
set(GAZEBO_DEFAULT_MASTER_HOST localhost)
set(GAZEBO_DEFAULT_MASTER_PORT 11345)
set(GAZEBO_RELATIVE_PLUGIN_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/gazebo-${GAZEBO_MAJOR_VERSION}/plugins)
set(GAZEBO_RELATIVE_PLUGIN_BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR}/gazebo-${GAZEBO_MAJOR_VERSION}/plugins)
set(GAZEBO_PLUGIN_LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${GAZEBO_RELATIVE_PLUGIN_LIB_INSTALL_DIR})
set(GAZEBO_PLUGIN_BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${GAZEBO_RELATIVE_PLUGIN_BIN_INSTALL_DIR})
if(WIN32)
  set(GAZEBO_RELATIVE_PLUGIN_PATH ${GAZEBO_RELATIVE_PLUGIN_BIN_INSTALL_DIR})
else()
  set(GAZEBO_RELATIVE_PLUGIN_PATH ${GAZEBO_RELATIVE_PLUGIN_LIB_INSTALL_DIR})
endif()
set(GAZEBO_PLUGIN_PATH ${CMAKE_INSTALL_PREFIX}/${GAZEBO_RELATIVE_PLUGIN_PATH})
FILE(TO_NATIVE_PATH "${GAZEBO_PLUGIN_PATH}" GAZEBO_PLUGIN_PATH)
set(GAZEBO_RELATIVE_MODEL_PATH ${CMAKE_INSTALL_DATAROOTDIR}/gazebo-${GAZEBO_MAJOR_VERSION}/models)
set(GAZEBO_MODEL_PATH ${CMAKE_INSTALL_PREFIX}/${GAZEBO_RELATIVE_MODEL_PATH})
FILE(TO_NATIVE_PATH "${GAZEBO_MODEL_PATH}" GAZEBO_MODEL_PATH)
set(GAZEBO_RELATIVE_RESOURCE_PATH ${CMAKE_INSTALL_DATAROOTDIR}/gazebo-${GAZEBO_MAJOR_VERSION})
set(GAZEBO_RESOURCE_PATH ${CMAKE_INSTALL_PREFIX}/${GAZEBO_RELATIVE_RESOURCE_PATH})
FILE(TO_NATIVE_PATH "${GAZEBO_RESOURCE_PATH}" GAZEBO_RESOURCE_PATH)
set(GAZEBO_MODEL_DATABASE_URI http://models.gazebosim.org)
set(OGRE_RESOURCE_PATH ${OGRE_PLUGINDIR})
# Seems that OGRE_PLUGINDIR can end in a newline, which will cause problems when
# we pass it to the compiler later.
string(REPLACE "\n" "" OGRE_RESOURCE_PATH ${OGRE_RESOURCE_PATH})


# Check for DRI capable Display
include (${gazebo_cmake_dir}/CheckDRIDisplay.cmake)

#####################################
MESSAGE(STATUS "Checking gazebo build type")
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo Profile Check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
# TODO: still convert to uppercase to keep backwards compatibility with
# uppercase old supported and deprecated modes
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPERCASE)

if (NOT DEFINED HDF5_INSTRUMENT)
  set (HDF5_INSTRUMENT FALSE)
endif()

set (GAZEBO_BUILD_TYPE_PROFILE FALSE)
set (GAZEBO_BUILD_TYPE_RELEASE FALSE)
set (GAZEBO_BUILD_TYPE_RELWITHDEBINFO FALSE)
set (GAZEBO_BUILD_TYPE_DEBUG FALSE)
set (GAZEBO_BUILD_TYPE_COVERAGE FALSE)

if ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "PROFILE")
  set (GAZEBO_BUILD_TYPE_PROFILE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELEASE")
  set (GAZEBO_BUILD_TYPE_RELEASE TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "RELWITHDEBINFO")
  set (GAZEBO_BUILD_TYPE_RELWITHDEBINFO TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "DEBUG")
  set (GAZEBO_BUILD_TYPE_DEBUG TRUE)
elseif ("${CMAKE_BUILD_TYPE_UPPERCASE}" STREQUAL "COVERAGE")
  BUILD_WARNING ("Simbody physics engine not supported during Coverage builds (issue #1849).")
  set (HAVE_SIMBODY FALSE)
  BUILD_WARNING ("DART physics engine not supported during Coverage builds (issue #1160).")
  set (HAVE_DART FALSE)
  set (GAZEBO_BUILD_TYPE_COVERAGE TRUE)
  include (${gazebo_cmake_dir}/CodeCoverage.cmake)
  setup_target_for_coverage(coverage coverage)
else()
  build_error("CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} unknown. Valid options are: Debug Release RelWithDebInfo Profile Check")
endif()

#####################################
# Handle CFlags
# USE_UPSTREAM_CFLAGS (default TRUE)
if(NOT DEFINED USE_UPSTREAM_CFLAGS)
    set (USE_UPSTREAM_CFLAGS True)
endif()

unset (CMAKE_C_FLAGS_ALL CACHE)

# USE_HOST_CFLAGS (default TRUE)
# Will check building host machine for proper cflags
if(NOT DEFINED USE_HOST_CFLAGS OR USE_HOST_CFLAGS)
  message(STATUS "Enable host CFlags")
  include (${gazebo_cmake_dir}/HostCFlags.cmake)
endif()

# Will use predefined gazebo developers cflags
# this needs to be called after HostCFlags
if(USE_UPSTREAM_CFLAGS)
  # use gazebo own set of flags
  unset (CMAKE_CXX_FLAGS CACHE)
  message(STATUS "Enable upstream CFlags")
  include(${gazebo_cmake_dir}/DefaultCFlags.cmake)
endif()

# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
if (MSVC)
  # Default Windows-MSVC.cmake sets MSVC warning flag to /W3. Add some extra warning excludes.
  set(WARN_LEVEL "/wd4005 /wd4068 /wd4244 /wd4251 /wd4267 /wd4275 /wd4996")
else()
  set(WARN_LEVEL "-Wall")
endif()
filter_valid_compiler_flags(${WARN_LEVEL}
  -Wextra -Wno-long-long -Wno-unused-value -Wfloat-equal -Wshadow
  -Wswitch-default -Wmissing-include-dirs -pedantic)

# Check and add visibility hidden by default. Only in UNIX
# Windows and MacosX does not handled properly the hidden compilation
if (UNIX AND NOT APPLE)
  if (ENABLE_PROFILER)
    filter_valid_compiler_flags(-fvisibility-inlines-hidden)
  else()
    filter_valid_compiler_flags(-fvisibility=hidden -fvisibility-inlines-hidden)
  endif()
endif()

if (MSVC)
  # Unable to be filtered flags (failing due to limitations in filter_valid_compiler_warnings)
  # Handling exceptions rightly
  set(UNFILTERED_FLAGS "/EHsc")
endif()

if (NOT MSVC)
  set(UNFILTERED_FLAGS "")
endif()

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${VALID_CXX_FLAGS} ${UNFILTERED_FLAGS}")

#################################################
# OS Specific initialization
if (UNIX)
  gz_setup_unix()
else (WIN32)
  gz_setup_windows()
endif()

if(APPLE)
  gz_setup_apple()
endif()

# Main includes for compilation
include_directories(${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR})
include_directories(SYSTEM ${IGNITION-MATH_INCLUDE_DIRS})

#################################################
# Configure 3rd Party Packages after OS Specific initialization
message (STATUS "\n\n====== Configuring 3rd Party Packages ======")
add_subdirectory(deps)

=== test/CMakeLists.txt ===
include_directories (
  ${ODE_INCLUDE_DIRS}
  ${OPENGL_INCLUDE_DIR}
  ${OGRE_INCLUDE_DIRS}
  ${SDFormat_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
)

link_directories(
  ${CCD_LIBRARY_DIRS}
  ${ogre_library_dirs}
  ${Boost_LIBRARY_DIRS}
  ${ODE_LIBRARY_DIRS}
  ${SDFormat_LIBRARY_DIRS}
)

if (HAVE_BULLET)
  link_directories(${BULLET_LIBRARY_DIRS})
endif()

configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

# Build gtest
if (WIN32)
  # Windows will fail to link the non-static libraries between gtest_main and
  # gtest unless .lib is created. It is easier to keep things static unless
  # other reasons appear.
  add_library(gtest STATIC gtest/src/gtest-all.cc)
  add_library(gtest_main STATIC gtest/src/gtest_main.cc)
else()
  # No static on UNIX to avoid problems on ARM platforms linking
  # with no fPIC
  add_library(gtest gtest/src/gtest-all.cc)
  add_library(gtest_main gtest/src/gtest_main.cc)
  target_link_libraries(gtest pthread)
endif()

target_link_libraries(gtest_main gtest)
execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(plugins)

set(TEST_TYPE "PERFORMANCE")
add_subdirectory(performance)
set(TEST_TYPE "INTEGRATION")
add_subdirectory(integration)
set(TEST_TYPE "EXAMPLE")
add_subdirectory(examples)
set(TEST_TYPE "REGRESSION")
add_subdirectory(regression)
add_subdirectory(cmake)
add_subdirectory(pkgconfig)

=== test/integration/CMakeLists.txt ===
include_directories (
  ${ODE_INCLUDE_DIRS}
  ${OPENGL_INCLUDE_DIR}
  ${OGRE_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${PROTOBUF_INCLUDE_DIR}
)

link_directories(
  ${ogre_library_dirs}
  ${Boost_LIBRARY_DIRS}
  ${ODE_LIBRARY_DIRS}
)
set (CMAKE_AUTOMOC ON)

# Disable the player test for now, until we figure out a better way to test them
#if (INCLUDE_PLAYER)
#  add_subdirectory(player)
#endif()

if(HAVE_BULLET)
  include_directories ( ${BULLET_INCLUDE_DIRS} )
  link_directories ( ${BULLET_LIBRARY_DIRS} )
endif()
if(HAVE_DART)
  include_directories ( ${DART_INCLUDE_DIRS} )
  link_directories ( ${DART_LIBRARY_DIRS} )
endif()

set(tests
  aero_plugin.cc
  attach_light_plugin.cc
  bandwidth.cc
  concave_mesh.cc
  contact_sensor.cc
  contacts_update.cc
  contain_plugin.cc
  dem.cc
  elastic_modulus.cc
  file_handling.cc
  flash_light_plugin.cc
  gripper.cc
  gz_joint.cc
  gz_log.cc
  gz_model.cc
  gz_physics.cc
  gz_world.cc
  harness.cc
  imu.cc
  info_services.cc
  introspection_items.cc
  joint_control_plugin.cc
  joint_controller.cc
  joint_force_torque.cc
  joint_gearbox.cc
  joint_get_force_torque.cc
  joint_revolute.cc
  joint_screw.cc
  joint_set_position_test.cc
  joint_spawn.cc
  joint_test.cc
  joint_universal.cc
  keys_to_joints.cc
  kinematic_loop.cc
  laser.cc
  led_plugin.cc
  link.cc
  logical_camera_sensor.cc
  misalignment_plugin.cc
  model.cc
  model_database.cc
  multirayshape.cc
  nested_model.cc
  noise.cc
  nondefault_world.cc
  obj_loader.cc
  physics.cc
  physics_base.cc
  physics_basic_controller_response.cc
  physics_collision.cc
  physics_friction.cc
  physics_inertia_ratio.cc
  physics_link.cc
  physics_msgs.cc
  physics_msgs_inertia.cc
  physics_presets.cc
  physics_solver.cc
  physics_thread_safe.cc
  physics_torsional_friction.cc
  pioneer2dx.cc
  plugin.cc
  plugin_interface.cc
  rayshape.cc
  region_events.cc
  rest_web.cc
  saving_and_loading.cc
  sdf.cc
  sdf_errors.cc
  sensor.cc
  sdf_frame_semantics.cc
  server_fixture.cc
  sim_events.cc
  speed.cc
  speed_thread_islands.cc
  speed_thread_pr2.cc
  static_map_plugin.cc
  stress_spawn_models.cc
  #state_log.cc
  surface_properties.cc
  swarm.cc
  touch_plugin.cc
  tracked_vehicles.cc
  transceiver.cc
  transport.cc
  transporter.cc
  variable_gearbox_plugin.cc
  wheel_slip.cc
  world.cc
  world_clone.cc
  world_entity_below_point.cc
  world_playback.cc
  world_population.cc
  worlds_installed.cc
  )

if (NOT WIN32)
  set(tests
    ${tests}
    transport_msg_count.cc
  )
endif()

if (NOT APPLE)
  set(tests
    ${tests}
    custom_shadow_caster.cc
  )
endif()

if (HAVE_GTS)
  set(tests
    ${tests}
    polyline.cc
  )
endif()

if (MANPAGES_SUPPORT)
  set (tests ${tests}
	      manpages.cc)
endif()

gz_build_tests(${tests} EXTRA_LIBS gazebo_test_fixture)

# Increase timeout, to account for model download time.
set_tests_properties(${TEST_TYPE}_joint_revolute PROPERTIES TIMEOUT 500)
set_tests_properties(${TEST_TYPE}_model_database PROPERTIES TIMEOUT 400)
set_tests_properties(${TEST_TYPE}_physics PROPERTIES TIMEOUT 500)
set_tests_properties(${TEST_TYPE}_worlds_installed PROPERTIES TIMEOUT 700)

set_property(
  SOURCE world_clone.cc
  PROPERTY COMPILE_DEFINITIONS
  GAZEBO_DEFAULT_MASTER_PORT=${GAZEBO_DEFAULT_MASTER_PORT}
)

# Increase timeout for debug-mode
if (${CMAKE_BUILD_TYPE_UPPERCASE} STREQUAL "DEBUG" OR
    ${CMAKE_BUILD_TYPE_UPPERCASE} STREQUAL "COVERAGE")
  set_tests_properties(${TEST_TYPE}_joint_gearbox PROPERTIES TIMEOUT 400)
endif()

# Add plugin dependency
add_dependencies(${TEST_TYPE}_joint_control_plugin JointControlPlugin)
add_dependencies(${TEST_TYPE}_joint_test SpringTestPlugin)
add_dependencies(${TEST_TYPE}_plugin ExceptionModelPluginConstructor)
add_dependencies(${TEST_TYPE}_plugin ExceptionModelPluginInit)
add_dependencies(${TEST_TYPE}_plugin ExceptionModelPluginLoad)
add_dependencies(${TEST_TYPE}_plugin_interface PluginInterfaceTest)
add_dependencies(${TEST_TYPE}_tracked_vehicles SimpleTrackedVehiclePlugin)
add_dependencies(${TEST_TYPE}_tracked_vehicles WheelTrackedVehiclePlugin)
add_dependencies(${TEST_TYPE}_variable_gearbox_plugin VariableGearboxPlugin)

set(display_tests
)

# Build the display tests (need extra sources to compile)
gz_build_display_tests(${display_tests})

set(dri_tests
  camera.cc
  camera_sensor.cc
  camera_sensor_igntransport.cc
  depth_camera.cc
  factory.cc
  fiducial.cc
  gpu_laser.cc
  gz_camera.cc
  heightmap.cc
  multicamera_sensor.cc
  ogre_log.cc
  pr2.cc
  projector.cc
  rendering_sensor.cc
  road.cc
  speed_pr2.cc
  visual.cc
  wideanglecamera_sensor.cc
  world_remove.cc
  world_reset.cc
)
gz_build_dri_tests(${dri_tests} EXTRA_LIBS gazebo_test_fixture)

set(qt_tests
  camera_gui.cc
  collada_visualization.cc
  force_torque_visualization.cc
  insert_model.cc
  joint_control_widget.cc
  marker.cc
  model_editor.cc
  model_editor_undo.cc
  model_manipulation.cc
  mouse_pick.cc
  track_visual.cc
  undo.cc
  view_angle.cc
  view_control.cc
  visual_pose.cc
)

gz_build_qt_tests(${qt_tests})

if (VALID_DRI_DISPLAY)
  add_dependencies(${TEST_TYPE}_heightmap HeightmapLODPlugin)
  # Increase timeout, to account for model download time.
  set_tests_properties(${TEST_TYPE}_factory PROPERTIES TIMEOUT 500)
  set_tests_properties(${TEST_TYPE}_pr2 PROPERTIES TIMEOUT 500)
  set_tests_properties(${TEST_TYPE}_pioneer2dx PROPERTIES TIMEOUT 500)
endif()

=== test/plugins/CMakeLists.txt ===
if (WIN32)
    add_definitions(-DBUILDING_DLL)
endif()

include_directories(
  ${PROJECT_SOURCE_DIR}
  ${PROTOBUF_INCLUDE_DIR}
  ${SDFormat_INCLUDE_DIRS}
  ${OGRE_INCLUDE_DIRS}
)

link_directories(
  ${SDFormat_LIBRARY_DIRS}
  ${CURL_LIBDIR}
  ${IGNITION-MATH_LIBRARY_DIRS}
)

if (HAVE_BULLET)
  link_directories(${BULLET_LIBRARY_DIRS})
endif()

set (plugins
  ExceptionModelPluginConstructor
  ExceptionModelPluginInit
  ExceptionModelPluginLoad
  ForceTorqueModelRemovalTestPlugin
  Issue1208Plugin
  ModelTrajectoryTestPlugin
  PluginInterfaceTest
  SpringTestPlugin
)

foreach (src ${plugins})
  add_library(${src} MODULE ${src}.cc)
  target_link_libraries(${src} libgazebo ${ogre_libraries})
  add_dependencies(tests ${src})
endforeach (src ${plugins})

target_link_libraries(PluginInterfaceTest gtest gtest_main)

=== test/regression/CMakeLists.txt ===
include_directories (
  ${ODE_INCLUDE_DIRS}
  ${OPENGL_INCLUDE_DIR}
  ${OGRE_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${PROTOBUF_INCLUDE_DIR}
)

link_directories(
  ${ogre_library_dirs}
  ${Boost_LIBRARY_DIRS}
  ${ODE_LIBRARY_DIRS}
)

if(HAVE_BULLET)
  include_directories ( ${BULLET_INCLUDE_DIRS} )
  link_directories ( ${BULLET_LIBRARY_DIRS} )
endif()
if(HAVE_DART)
  include_directories ( ${DART_INCLUDE_DIRS} )
  link_directories ( ${DART_LIBRARY_DIRS} )
endif()

set(tests
  351_world_step.cc
  494_joint_axis_frame.cc
  602_unsubscribe_segfault.cc
  624_collision_world_pose.cc
  876_random_number_generator.cc
  940_force_torque_sensor_frame.cc
  978_joint_anchor.cc
  1082_pid_limits.cc
  1112_force_torque_model_removal.cc
  1124_collision_pose.cc
  1146_collision_bounding_box.cc
  1208_world_plugin_init.cc
  1375_world_reset.cc
  1569_hydra_crash.cc
  1694_world_accel.cc
  1782_unadvertise.cc
  2239_revolute2_teleport.cc
  2297_log_insertions_paused.cc
  2428_log_insertions.cc
  2430_revolute_joint_SetPosition.cc
  2505_revolute_joint_SetAxis.cc
  2527_distortion_leak.cc
  2728_nested_urdf.cc
  2875_connect_pub_to_sub_crash.cc
  2896_gazebo_subnamespace.cc
  2902_performance_metrics_deadlock.cc
)
gz_build_tests(${tests} EXTRA_LIBS gazebo_test_fixture)

set(display_tests
)

# Build the display tests (need extra sources to compile)
gz_build_display_tests(${display_tests})

set(dri_tests
  346_save_lights.cc
  846_typo_in_camera.cc
  1702_remove_model_scene_nodes.cc
)
gz_build_dri_tests(${dri_tests} EXTRA_LIBS gazebo_test_fixture)

add_dependencies(${TEST_TYPE}_1112_force_torque_model_removal
                 ForceTorqueModelRemovalTestPlugin)
add_dependencies(${TEST_TYPE}_1208_world_plugin_init
                 Issue1208Plugin)

set (CMAKE_AUTOMOC ON)
set(qt_tests
  2728_gui_spawned_nested_urdf.cc
)

gz_build_qt_tests(${qt_tests})

=== debian/changelog ===
gazebo (11.8.0+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild against libtinyxml2-9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Nov 2021 17:34:17 +0000

gazebo (11.8.0+dfsg-1) unstable; urgency=medium

  * Install setup.* since there is a bash file in latest
  * New upstream version 11.8.0+dfsg
  * Update gtest patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 18 Aug 2021 17:09:30 +0000

gazebo (11.5.1+dfsg-3) experimental; urgency=medium

  * Remove previous patch, not working
  * Call default dh_auto_build in build-indep to get examples and worlds installed for gazebo-common

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 03 Jun 2021 14:06:46 +0000

gazebo (11.5.1+dfsg-2) experimental; urgency=medium

  * Include patch to make gazebo_test_fixture in ALL cmake target

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 26 May 2021 17:10:47 +0000

gazebo (11.5.1+dfsg-1) experimental; urgency=medium

  * Update debian/gitlab-ci.yml file
  * Bump compat to 13 and standards to 4.5.1
  * Exclude windows bat script and github actions code
  * Refresh patches to the new version
  * Remove patch merged upstream
  * New upstream version 11.5.1+dfsg

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 21 May 2021 15:09:15 +0000

=== debian/control ===
Source: gazebo
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper-compat (= 13),
               bash-completion,
               doxygen,
               doxygen-latex,
               texlive-fonts-recommended,
               fonts-liberation,
               fonts-roboto-unhinted,
               fonts-dejavu-core,
               libgraphviz-dev,
               libccd-dev,
               libopenal-dev,
               libfreeimage-dev,
               libprotoc-dev,
               libprotobuf-dev,
               protobuf-compiler,
               freeglut3-dev,
               libcurl4-openssl-dev | libcurl-dev,
               libtinyxml-dev,
               libtinyxml2-dev,
               libtar-dev,
               libtbb-dev,
               libogre-1.9-dev,
               libxml2-dev,
               qtbase5-dev,
               libqwt-qt5-dev,
               libqt5opengl5-dev,
               libqtpropertybrowser-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-iostreams-dev,
               libgts-dev,
               libavformat-dev,
               libavcodec-dev,
               libswscale-dev,
               libusb-1.0-0-dev,
               libspnav-dev,
               libsdformat-dev (>= 9),
               libignition-math-dev (>= 6),
               libignition-transport-dev (>= 8),
               libignition-msgs-dev (>= 5),
               libignition-common-dev (>= 3),
               libignition-fuel-tools-dev (>= 4),
               libbullet-dev,
               libsimbody-dev,
               libgdal-dev,
               libdart-all-dev,
               libdart-external-ikfast-dev,
               libdart-external-imgui-dev,
               libdart-external-lodepng-dev,
               libdart-external-odelcpsolver-dev,
               ronn,
               xsltproc,
               libgtest-dev,
               libtinyobjloader-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/gazebo
Vcs-Git: https://salsa.debian.org/science-team/gazebo.git
Homepage: http://gazebosim.org/

Package: gazebo-common
Architecture: all
Multi-Arch: foreign
Depends: fonts-dejavu-core,
         fonts-liberation,
         ${misc:Depends}
Breaks: gazebo7-common, gazebo9-common (<< 11.0.0+dfsg-1~)
Replaces: gazebo7-common, gazebo9-common (<< 11.0.0+dfsg-1~)
Description: Open Source Robotics Simulator - Shared files
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package contains shared files such as 3d models, worlds and
 robots.

Package: gazebo9-common
Depends: gazebo-common, ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: gazebo
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libgazebo11 (= ${binary:Version}),
         gazebo-common (= ${source:Version})
Recommends: gazebo-plugin-base
Suggests: gazebo-doc
Breaks: gazebo7, gazebo9 (<< 11.0.0+dfsg-1~)
Replaces: gazebo7, gazebo9 (<< 11.0.0+dfsg-1~)
Description: Open Source Robotics Simulator - Binaries
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package contains then main application binaries

Package: gazebo9
Depends: gazebo, ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libgazebo11
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open Source Robotics Simulator - shared library
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package gathers shared libraries used

Package: libgazebo-dev
Architecture: any
Section: libdevel
Depends: libtbb-dev,
         libxml2-dev,
         qtbase5-dev,
         fonts-liberation,
         fonts-dejavu-core,
         libqwt-qt5-dev,
         libprotoc-dev,
         libfreeimage-dev,
         libprotobuf-dev,
         libboost-dev,
         freeglut3-dev,
         libogre-1.9-dev,
         libtar-dev,
         libcurl4-openssl-dev | libcurl-dev,
         libgdal-dev,
         libavformat-dev,
         libavcodec-dev,
         libswscale-dev,
         libignition-math-dev (>= 6),
         libignition-transport-dev (>= 8),
         libignition-msgs-dev (>= 5),
         libignition-fuel-tools-dev (>= 4),
         libsdformat-dev (>= 9),
         libbullet-dev,
         libsimbody-dev,
         libdart-dev,
         libgazebo11 (= ${binary:Version}),
         gazebo-common (= ${source:Version}),
         gazebo-plugin-base (= ${binary:Version}),
         ${misc:Depends},
         ${protobuf:API},
Breaks: libgazebo7-dev, libgazebo9-dev (<< 11.0.0+dfsg-1~)
Replaces: libgazebo7-dev, libgazebo9-dev (<< 11.0.0+dfsg-1~)
Description: Open Source Robotics Simulator - Development Files
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package contains development files (headers, shared library
 symbolic link and pkg-config file).

Package: libgazebo9-dev
Depends: libgazebo-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: gazebo-plugin-base
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends}
Enhances: gazebo
Breaks: gazebo7-plugin-base, gazebo9-plugin-base (<< 11.0.0+dfsg-1~)
Replaces: gazebo7-plugin-base, gazebo9-plugin-base (<< 11.0.0+dfsg-1~)
Description: Open Source Robotics Simulator - base plug-ins
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package gathers built-in plugins.

Package: gazebo9-plugin-base
Depends: gazebo-plugin-base, ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: gazebo-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Breaks: gazebo7-doc, gazebo9-doc (<< 11.0.0+dfsg-1~)
Replaces: gazebo7-doc, gazebo9-doc (<< 11.0.0+dfsg-1~)
Description: Open Source Robotics Simulator - Documentation
 Gazebo is a multi-robot simulator for outdoor environments. Like
 Stage (part of the Player project), it is capable of simulating a
 population of robots, sensors and objects, but does so in a
 three-dimensional world. It generates both realistic sensor feedback
 and physically plausible interactions between objects (it includes an
 accurate simulation of rigid-body physics).
 .
 This package contains the program documentation.

Package: gazebo9-doc
Depends: gazebo-doc, ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.
